(() => {

'use strict'; 
goog.require('Blockly.Arduino');
goog.require('Mixly.Config');

const { Config } = Mixly;
const BOARDS_TYPE = Config.BOARD.boardType;

// ʼQMC5883Lģ
switch (BOARDS_TYPE) {
    case 'Arduino AVR':	
Blockly.Arduino.forBlock['PS2X_init'] = function () {
	Blockly.Arduino.definitions_['adefine21_PS2X_init'] = 'PS2X ps2x;';

	Blockly.Arduino.setups_['setup01_PS2X_init'] = //'ps2x.config_gamepad(13,11,10,12, true, true);';
		heredoc(function () {/*
       
  int error = 0;
  do{
    error = ps2x.config_gamepad(13,11,10,12, true, true);
    if(error == 0){
      break;
    }else{
      delay(100);
    }
  }while(1); 
  for(size_t i = 0; i < 50; i++)
  {
        ps2x.read_gamepad(false, 0);
        delay(10);
  }
*/});
	return "ps2x.read_gamepad(false, 0);\ndelay(3);\n";
};
    	        break;
    default:
Blockly.Arduino.forBlock['PS2X_init'] = function () {
	Blockly.Arduino.definitions_['adefine21_PS2X_init'] = 'PS2X ps2x;';

	Blockly.Arduino.setups_['setup01_PS2X_init'] = //'ps2x.config_gamepad(13,11,10,12, true, true);';
		heredoc(function () {/*
       
  int error = 0;
  do{
    error = ps2x.config_gamepad(18,23,5,19, true, true);
    if(error == 0){
      break;
    }else{
      delay(100);
    }
  }while(1); 
  for(size_t i = 0; i < 50; i++)
  {
        ps2x.read_gamepad(false, 0);
        delay(10);
  }
*/});
	return "ps2x.read_gamepad(false, 0);\ndelay(3);\n";
};

}

function heredoc(fn) {
	return fn.toString().split('\n').slice(1, -1).join('\n') + '\n'
}



//readcardnum
Blockly.Arduino.forBlock['PS2X_Button'] = function () {
	var bt = this.getFieldValue('psbt');
	var btstate = this.getFieldValue('btstate');
	if (btstate == "1") {
		var st = "ps2x.Button(" + bt + ")";
	} else {
		var st = "ps2x.ButtonReleased(" + bt + ")";
	}
	return [st, Blockly.Arduino.ORDER_ATOMIC];
};

Blockly.Arduino.forBlock['PS2X_stk'] = function () {
	var stk = this.getFieldValue('psstk');
	var st = "ps2x.Analog(" + stk + ")";
	return [st, Blockly.Arduino.ORDER_ATOMIC];
};

Blockly.Arduino.forBlock['PS2X_vibrate'] = function () {
	return "ps2x.read_gamepad(true, 200);\ndelay(300);\nps2x.read_gamepad(false, 0);\n";
};

Blockly.Arduino.forBlock['Motor_init'] = function () {
	Blockly.Arduino.definitions_['adefine00_Wire'] = '#include <Wire.h>';
	Blockly.Arduino.definitions_['adefine01_PS2X'] = '#include <PS2X_lib.h>';
	Blockly.Arduino.definitions_['adefine02_PWMServoDriver'] = '#include <Adafruit_MS_PWMServoDriver.h>';
	Blockly.Arduino.definitions_['adefine03_MotorShield'] = '#include "QGPMaker_MotorShield.h"';
	
	
	Blockly.Arduino.definitions_['adefine20_Motor_init'] = 'QGPMaker_MotorShield AFMS = QGPMaker_MotorShield();  ';

	Blockly.Arduino.setups_['setup00_Motor_init_1'] = 'AFMS.begin(50); ';
	return '';
};


Blockly.Arduino.forBlock['DCMotorRun'] = function () {
	var motor = this.getFieldValue('motor');
	var direction = this.getFieldValue('direction');
	var speed = Blockly.Arduino.valueToCode(this, 'speed', Blockly.Arduino.ORDER_ATOMIC);
	var vcode = "";
	var dcMotor = "DCMotor_" + motor;
	Blockly.Arduino.definitions_['adefine21_motorRun_' + motor] = 'QGPMaker_DCMotor *' + dcMotor + ' = AFMS.getMotor(' + motor + ');';
	vcode = dcMotor + "->setSpeed(" + speed + ");\n" + dcMotor + "->run(" + direction + ");\n";
	return vcode;
};

Blockly.Arduino.forBlock['DCMotorStop'] = function () {
	var motor = this.getFieldValue('motor');
	var vcode = "";
	var dcMotor = "DCMotor_" + motor;
	Blockly.Arduino.definitions_['adefine21_motorRun_' + motor] = 'QGPMaker_DCMotor *' + dcMotor + ' = AFMS.getMotor(' + motor + ');';
	vcode = dcMotor + "->setSpeed(0);\n" + dcMotor + "->run(RELEASE);\n";
	return vcode;
};

Blockly.Arduino.forBlock['SERVO_init'] = function () {
	var servo = this.getFieldValue('servo');
	var value_degree = Blockly.Arduino.valueToCode(this, 'DEGREE', Blockly.Arduino.ORDER_ATOMIC);
	var vcode = "";
	var XServo = "Servo" + servo;
	Blockly.Arduino.definitions_['adefine22_Servo_' + servo] = 'QGPMaker_Servo *' + XServo + ' = AFMS.getServo(' + servo + ');';
	vcode = XServo + "->writeServo(" + value_degree + ");";
	Blockly.Arduino.setups_['setup02_SERVO_init_' + servo] = vcode;
	return '';
};

Blockly.Arduino.forBlock['SERVO'] = function () {
	var servo = this.getFieldValue('servo');
	var value_degree = Blockly.Arduino.valueToCode(this, 'DEGREE', Blockly.Arduino.ORDER_ATOMIC);
	var vcode = "";
	var XServo = "Servo" + servo;
	Blockly.Arduino.definitions_['adefine22_Servo_' + servo] = 'QGPMaker_Servo *' + XServo + ' = AFMS.getServo(' + servo + ');';
	vcode = XServo + "->writeServo(" + value_degree + ");";
	return vcode;
};


Blockly.Arduino.forBlock['ReadSERVO'] = function () {
	var servo = this.getFieldValue('servo');
	var XServo = "Servo" + servo;
	Blockly.Arduino.definitions_['adefine22_Servo_' + servo] = 'QGPMaker_Servo *' + XServo + ' = AFMS.getServo(' + servo + ');';
	var vcode = XServo + "->readDegrees()";
	return [vcode, Blockly.Arduino.ORDER_ATOMIC];
};

Blockly.Arduino.forBlock['SetPWM'] = function () {
	var _pin = this.getFieldValue('pin');
	var pwmVal = Blockly.Arduino.valueToCode(this, 'pwmVal', Blockly.Arduino.ORDER_ATOMIC);
	var vcode = "";
	vcode = "AFMS.setPWM("+_pin+","+pwmVal+");";
	return vcode;
};

Blockly.Arduino.forBlock['SetPWMPin'] = function () {
	var _pin = this.getFieldValue('pin');
	var pwmVal = this.getFieldValue('pinVal');
	var vcode = "";
	vcode = "AFMS.setPin("+_pin+","+pwmVal+");";
	return vcode;
};

Blockly.Arduino.forBlock['ReadEncoder'] = function () {
	var encoder = this.getFieldValue('motor');
	var XEncoder = "Encoder" + encoder;
	var vcode = XEncoder + ".read()";
	return [vcode, Blockly.Arduino.ORDER_ATOMIC];
};

Blockly.Arduino.forBlock['ReadEncoderRPM'] = function () {
	var encoder = this.getFieldValue('motor');
	var XEncoder = "Encoder" + encoder;
	var vcode = XEncoder + ".getRPM()";
	return [vcode, Blockly.Arduino.ORDER_ATOMIC];
};


Blockly.Arduino.forBlock['SetEncoder'] = function () {
	var encoder = this.getFieldValue('motor');
	var enVal = Blockly.Arduino.valueToCode(this, 'encoder', Blockly.Arduino.ORDER_ATOMIC);
	var ppr = Blockly.Arduino.valueToCode(this, 'ppr', Blockly.Arduino.ORDER_ATOMIC);
	var grate = Blockly.Arduino.valueToCode(this, 'grate', Blockly.Arduino.ORDER_ATOMIC);
	var XEncoder = "Encoder" + encoder;
	Blockly.Arduino.definitions_['adefine04_QGPMakerEncoder'] = '#include "QGPMaker_Encoder.h"';
	Blockly.Arduino.definitions_['adefine22_Encoder_' + encoder] = 'QGPMaker_Encoder ' + XEncoder + '(' + encoder + ',4*'+ppr+'*'+grate+');';
	Blockly.Arduino.setups_['setup60_ENCODE_init_1'] = XEncoder+".write("+enVal+");";
	var vcode = "";
	
	return vcode;
};

Blockly.Arduino.forBlock['ResetEncoder'] = function () {
	var encoder = this.getFieldValue('motor');
	var XEncoder = "Encoder" + encoder;
	//Blockly.Arduino.definitions_['adefine22_Encoder_' + encoder] = 'QGPMaker_Encoder ' + XEncoder + '(' + encoder + ');';
	var enVal = Blockly.Arduino.valueToCode(this, 'encoder0', Blockly.Arduino.ORDER_ATOMIC);
	var vcode = "";
	vcode = XEncoder+".write("+enVal+");";
	return vcode;
};


Blockly.Arduino.forBlock['IICSensorbar_Init'] = function () {
	Blockly.Arduino.definitions_['adefine050_IICSensorbar'] = '#include "QGPMaker_IICSensorbar.h"';

	var addr = this.getFieldValue('addr');
	var XSenbar= "sensorbar";
	Blockly.Arduino.definitions_['adefine33_IICSenbar_0' ] = 'SensorBar ' + XSenbar + ' ;';
	var vcode = XSenbar + ".begin(" + addr + ");";
	Blockly.Arduino.setups_['setup30_IICsensorbar_init_0'] = vcode;
	return '';
};

Blockly.Arduino.forBlock['IICSensorbar_DigitalWrite'] = function () {
	var sen = this.getFieldValue('sen');
	var senVal = Blockly.Arduino.valueToCode(this, 'senVal', Blockly.Arduino.ORDER_ATOMIC);
	var XSenbar= "sensorbar";
	var vcode = XSenbar + ".pinMode("+sen+", OUTPUT);";
	Blockly.Arduino.setups_['setup30_IICsensorbar_DigitalWriteMode_'+sen] = vcode;
	return XSenbar+'.digitalWrite('+sen+','+senVal+');';
};


Blockly.Arduino.forBlock['IICSensorbar_DigitalRead'] = function () {
	var sen = this.getFieldValue('sen');
	var XSenbar= "sensorbar";
	var vcode = XSenbar + ".pinMode("+sen+", INPUT);";
	Blockly.Arduino.setups_['setup30_IICsensorbar_DigitalWriteMode_'+sen] = vcode;
	return [XSenbar+'.digitalRead('+sen+')', Blockly.Arduino.ORDER_ATOMIC];
};

Blockly.Arduino.forBlock['IICSensorbar_AnalogWrite'] = function () {
	var sen = this.getFieldValue('sen');
	var senVal = Blockly.Arduino.valueToCode(this, 'senVal', Blockly.Arduino.ORDER_ATOMIC);
	var XSenbar= "sensorbar";
	var vcode = XSenbar + ".pinMode("+sen+", ANALOG_OUTPUT);";
	Blockly.Arduino.setups_['setup30_IICsensorbar_DigitalWriteMode_'+sen] = vcode;
	return XSenbar+'.analogWrite('+sen+','+senVal+');';
};





Blockly.Arduino.forBlock['auto_connect'] = function() {
	var value_blename = Blockly.Arduino.valueToCode(this, 'blename', Blockly.Arduino.ORDER_ATOMIC);
	Blockly.Arduino.definitions_['include_'+'AsyncFSBrowser'] = '#include "AsyncFSBrowser.h"';
	Blockly.Arduino.definitions_['include_'+'BleServer'] = '#include "BleServer.h"';
	Blockly.Arduino.definitions_['BleServerINIT'] = 'BleServer bleServer; ';
	Blockly.Arduino.setups_['BleServerSETUP'] = 'bleServer.setupBleServe((char*)'+value_blename+');\n setupWebServer(); ';
	var code = '';
	return '';
  };



Blockly.Arduino.forBlock['mqtt_connect'] = function() {
	var value_server = Blockly.Arduino.valueToCode(this, 'server', Blockly.Arduino.ORDER_ATOMIC);
	var value_port = Blockly.Arduino.valueToCode(this, 'port', Blockly.Arduino.ORDER_ATOMIC);
	var value_mqtt_username = Blockly.Arduino.valueToCode(this, 'mqtt_username', Blockly.Arduino.ORDER_ATOMIC);
	var value_mqtt_password = Blockly.Arduino.valueToCode(this, 'mqtt_password', Blockly.Arduino.ORDER_ATOMIC);
	var value_project = Blockly.Arduino.valueToCode(this, 'project', Blockly.Arduino.ORDER_ATOMIC);
	Blockly.Arduino.definitions_['include_'+'WFJOYSTIC'] = '#include "WFJoystick.h"';
	Blockly.Arduino.definitions_['WFJoystickInit'] = 'WFJoystick wfJoy('+value_server
	+', '+value_port
	+', '+value_mqtt_username
	+', '+value_mqtt_password
	+', '+value_project
	+');';
	Blockly.Arduino.setups_['WFJoystickBegin'] = 'wfJoy.begin();';
	var code = 'wfJoy.readCommand();';
	return code;
  };

  
//readcardnum
Blockly.Arduino.forBlock['VJ_Button'] = function () {
	var bt = this.getFieldValue('psbt');
	var btstate = this.getFieldValue('btstate');
	if (btstate == "1") {
		var st = "wfJoy.Button(" + bt + ")";
	} else {
		var st = "wfJoy.ButtonReleased(" + bt + ")";
	}
	return [st, Blockly.Arduino.ORDER_ATOMIC];
};

Blockly.Arduino.forBlock['VJ_stk'] = function () {
	var stk = this.getFieldValue('psstk');
	var st = "wfJoy.Analog(" + stk + ")";
	return [st, Blockly.Arduino.ORDER_ATOMIC];
};


})();